#*-*coding:utf-8*-*
""" outil de gestion des fichiers de règles du pare-feu """

from amon.backend import get_other_interfaces, get_interfaces
from os.path import isfile

f_name_tmpl = "/usr/share/ead2/backend/tmp/regles.csv"
regles_tmpl = "%(desc)s,%(val)s,%(occ)s,%(eth)s"

def load(zone, libelle=False):
    """
        renvoie la liste des règles optionnelles era pour la zone zone
    """
    f_name = f_name_tmpl
    if isfile(f_name):
        rules = []
        lines = file(f_name).read().splitlines()
        # règles de la zone 'zone'
        for line in file(f_name).read().splitlines():

            eth = line.split(',')[3]
            if eth in get_interfaces(zone):
                rule = {'desc':line.split(',')[0],
                              'val':line.split(',')[1],
                              'occ':line.split(',')[2],
                              'eth':line.split(',')[3]}
                if libelle:
                    rule['libelle'] = line.split(',')[0]
                rules.append(rule)
                lines.remove(line)
        # règles des interfaces sans zone (bastion ,extérieur...)
        for line in lines:
            eth = line.split(',')[3]
            if eth not in get_other_interfaces(zone):
                rule = {'desc':line.split(',')[0],
                              'val':line.split(',')[1],
                              'occ':line.split(',')[2],
                              'eth':line.split(',')[3]}
                if libelle:
                    rule['libelle'] = '<b>%s</b>'%line.split(',')[0]

                rules.append(rule)
        return rules
    return []

def save(zone, result):
    """
        sauvegarde la configuration des règles optionnelles
    """
    lines = []
    for val in result:
        lines.append(regles_tmpl%val)
    f_name = f_name_tmpl
    if lines:
        f_ = file(f_name, 'w')
        f_.write('\n'.join(lines))
        f_.close()
    return True
